hdu1298 T9(手机输入法,每按一个数字,找出出现频率最高的字串,字典树+DFS)

Problem Description

A while ago it was quite cumbersome to create a message for the Short Message Service (SMS) on a mobile phone. This was because you only have nine keys and the alphabet has more than nine letters, so most characters could only be
entered by pressing one key several times. For example, if you wanted to type "hello" you had to press key 4 twice, key 3 twice, key 5 three times, again key 5 three times, and finally key 6 three times. This procedure is very tedious and keeps many people
from using the Short Message Service.

This led manufacturers of mobile phones to try and find an easier way to enter text on a mobile phone. The solution they developed is called T9 text input. The "9" in the name means that you can enter almost arbitrary words with just nine keys and without pressing
them more than once per character. The idea of the solution is that you simply start typing the keys without repetition, and the software uses a built-in dictionary to look for the "most probable" word matching the input. For example, to enter "hello" you
simply press keys 4, 3, 5, 5, and 6 once. Of course, this could also be the input for the word "gdjjm", but since this is no sensible English word, it can safely be ignored. By ruling out all other "improbable" solutions and only taking proper English words
into account, this method can speed up writing of short messages considerably. Of course, if the word is not in the dictionary (like a name) then it has to be typed in manually using key repetition again.

Figure 8: The Number-keys of a mobile phone.

More precisely, with every character typed, the phone will show the most probable combination of characters it has found up to that point. Let us assume that the phone knows about the words "idea" and "hello", with "idea" occurring more often. Pressing the
keys 4, 3, 5, 5, and 6, one after the other, the phone offers you "i", "id", then switches to "hel", "hell", and finally shows "hello".

Write an implementation of the T9 text input which offers the most probable character combination after every keystroke. The probability of a character combination is defined to be the sum of the probabilities of all words in the dictionary that begin with
this character combination. For example, if the dictionary contains three words "hell", "hello", and "hellfire", the probability of the character combination "hell" is the sum of the probabilities of these words. If some combinations have the same probability,
your program is to select the first one in alphabetic order. The user should also be able to type the beginning of words. For example, if the word "hello" is in the dictionary, the user can also enter the word "he" by pressing the keys 4 and 3 even if this
word is not listed in the dictionary.

Input

The first line contains the number of scenarios.

Each scenario begins with a line containing the number w of distinct words in the dictionary (0<=w<=1000). These words are given in the next w lines. (They are not guaranteed in ascending alphabetic order, although it‘s a dictionary.) Every line starts with
the word which is a sequence of lowercase letters from the alphabet without whitespace, followed by a space and an integer p, 1<=p<=100, representing the probability of that word. No word will contain more than 100 letters.

Following the dictionary, there is a line containing a single integer m. Next follow m lines, each consisting of a sequence of at most 100 decimal digits 2-9, followed by a single 1 meaning "next word".

Output

The output for each scenario begins with a line containing "Scenario #i:", where i is the number of the scenario starting at 1.

For every number sequence s of the scenario, print one line for every keystroke stored in s, except for the 1 at the end. In this line, print the most probable word prefix defined by the probabilities in the dictionary and the T9 selection rules explained above.
Whenever none of the words in the dictionary match the given number sequence, print "MANUALLY" instead of a prefix.

Terminate the output for every number sequence with a blank line, and print an additional blank line at the end of every scenario.

Sample Input

2
5
hell 3
hello 4
idea 8
next 8
super 3
2
435561
43321
7
another 5
contest 6
follow 3
give 13
integer 6
new 14
program 4
5
77647261
6391
4681
26684371
77771

Sample Output

Scenario #1:
i
id
hel
hell
hello

i
id
ide
idea

Scenario #2:
p
pr
pro
prog
progr
progra
program

n
ne
new

g
in
int

c
co
con
cont
anoth
anothe
another

p
pr
MANUALLY
MANUALLY

题意:首先给定n组字符串s和数字a,表示该字符串s输入过a次,接下来q次输入,每次输入表示按键顺序(使用手机输入发那种),问每次按键可能出现的字符串,按使用频率高的输出,若没有则输出MANUALLY

注意:每个数字代表一个字母,如果要找出两个长度的答案,那么在两个长度的所有可能中找出出现频率最高的。
#include<stdio.h>
#include<string.h>
//#include<malloc.h>

typedef struct nn
{
    int prio;
    struct nn *next[26];
}node;
typedef struct nnn
{
    int maxprio;
    char str[105];
}ansseme;

node *builde()
{
    int i;
    node *p=new node;//node *p=(node*)malloc(sizeof(node));
    p->prio=0;
    for(i=0;i<26;i++)
    p->next[i]=NULL;
    return p;
}
node *root;
void insert(char str[],int prio)
{
    node *p=root;
    int i;
    for(i=0;str[i]!='\0';i++)
    {
        if(p->next[str[i]-'a']==NULL)
        p->next[str[i]-'a']=builde();
        p=p->next[str[i]-'a'];
        p->prio+=prio;
    }
}
int l;
char num[105];
ansseme prin[105];
char ch[10][5]={"abc","def","ghi","jkl","mno","pqrs","tuv","wxyz"};
void dfs(int i,node *p,char pre[])
{
    int len=strlen(ch[num[i]-'2']),ti=0,cc[4],pri[4],j;
    for( j=0;j<len;j++)
    if(p->next[ch[num[i]-'2'][j]-'a']!=NULL)
    {
        pri[ti]=p->next[ch[num[i]-'2'][j]-'a']->prio;
        cc[ti++]=ch[num[i]-'2'][j]-'a';
    }
    for( j=0;j<ti;j++)
    {
       pre[i]=cc[j]+'a'; pre[i+1]='\0';
        if(prin[i].maxprio<pri[j])
        {
            prin[i].maxprio=pri[j]; strcpy(prin[i].str,pre);
        }
        if(l>i+1) dfs(i+1,p->next[cc[j]],pre);
    }
}
int main()
{
    int t,cas=0,n,prio,i;
    char str[105];
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d",&n);
        printf("Scenario #%d:\n",++cas);
        root=builde();
        while(n--)
        {
            scanf("%s %d",str,&prio);
            insert(str,prio);
        }
        scanf("%d",&n);
        while(n--)
        {
            scanf("%s",num);
            l=strlen(num)-1;
            for( i=0;i<=l;i++)
            prin[i].maxprio=0;
            str[0]='\0';

             if(l)  dfs(0,root,str);
             for( i=0;i<l;i++)
             if(prin[i].maxprio)
             printf("%s\n",prin[i].str);
             else
             printf("MANUALLY\n");
           printf("\n");
        }
        printf("\n");
    }
}

hdu1298 T9(手机输入法,每按一个数字,找出出现频率最高的字串,字典树+DFS)

时间: 2024-12-20 07:01:30

hdu1298 T9(手机输入法,每按一个数字,找出出现频率最高的字串,字典树+DFS)的相关文章

编写一个程序找出100~999之间所有的水仙花数

如果一个3位数等于其各位的立方和,称该数为水仙花数. 如,所以407是一个水仙花数,编写一个程序找出100~999之间所有的水仙花数. 1 #include<stdio.h> 2 #include<stdlib.h> 3 //判断水仙花数,是则返回1 4 int isNarcissus(int n); 5 6 int main() 7 { 8 int i; 9 for(i = 100; i < 1000; i++) 10 if(isNarcissus(i)) 11 print

java-第七章-数组-一组数字找出最低分,并找出他的下标

public static void main(String[] args) { // TODO Auto-generated method stub int integarl [] = new int []{18,25,7,36,13,2,89,63}; int min=integarl[0],index=0; for (int i = 0; i < integarl.length; i++) { if(integarl[i]<min){ min=integarl[i]; index=i+1

使用一个函数找出一个整型数组中的最大值和最小值

/***************************************************** 知识点:bool类型,命名空间,输入输出 题目要求: 使用一个函数找出一个整型数组中的最大值和最小值 *****************************************************/ #include<stdlib.h> #include<iostream> using namespace std; namespace CJJ // 定义命名空间

hdu 1298 T9(字典树+DFS)

题目连接:hdu 1298 T9 题目大意:模拟手机打字的猜想功能,根据概率,每按一个按键,输出可能性最高的串.先给定N个单词,以及频率, 然后是Q次询问,每次询问给定一个按按键的顺序,以1为终止. 解题思路:对单词表建立字典树,每个节点有一个经过的频率,这个频率是根据所有经过该节点的单词频率总和.然后 DFS搜索一遍,将答案保存在ans中. #include <cstdio> #include <cstring> #include <algorithm> using

100亿个数字找出最大的10个

1.首先一点,对于海量数据处理,思路基本上是确定的,必须分块处理,然后再合并起来. 2.对于每一块必须找出10个最大的数,因为第一块中10个最大数中的最小的,可能比第二块中10最大数中的最大的还要大. 3.分块处理,再合并.也就是Google MapReduce 的基本思想.Google有很多的服务器,每个服务器又有很多的CPU,因此,100亿个数分成100块,每个服务器处理一块,1亿个数分成100块,每个CPU处理一块.然后再从下往上合并.注意:分块的时候,要保证块与块之间独立,没有依赖关系,

输入一串数字找出其中缺少的最小的两个数

Description There is a permutation without two numbers in it, and now you know what numbers the permutation has. Please find the two numbers it lose. Input There is a number Tshows there are T test cases below. (T<=10)  For each test case , the first

HDU 1298 T9(字典树+dfs)

http://acm.hdu.edu.cn/showproblem.php?pid=1298 题意:模拟手机9键,给出每个单词的使用频率.现在给出按键的顺序,问每次按键后首字是什么(也就是要概率最大的). 思路: 先建立字典树算出每个前缀出现的概率,然后dfs每种情况,选择概率大的. 1 #include<iostream> 2 #include<cstdio> 3 #include<cstring> 4 using namespace std; 5 const int

一个数组中只有两个数是不同的,其他数字是成对出现的,下面代码可将该数组中不同的两数字找出并输出

#include<stdio.h>int main(){ void function(int * str, int size, int *p1, int *p2); int i = 0; int num1 = 0, num2 = 0; int arr[10] = {0}; int len = sizeof(arr) / sizeof(arr[0]); for (i = 0; i < len; i++) {  scanf("%d", &arr[i]); }  f

从一个文本文件中找出使用频率最高的五个字符

1 #include <stdio.h> 2 #define N 95 //可打印字符总数 3 #define space 32 //空格符ASCII码 4 5 int main() 6 { 7 char cNum[N] = {0}, ch; 8 int iNum[N] = {0}; 9 int i, j, k, iMax, tag, h = 5; 10 11 FILE* fp = fopen("file.txt", "r"); 12 if(NULL =